/*
  f-cpu/c/eu_inc/eu_inc.h
  inc eu ports for F-CPU simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version: 19 July 2002 13:30

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------

*/

#ifndef EU_INC_H
#define EU_INC_H

#include <f-cpu_config.h>

/* (def of consts is has to be moved somwhere else (f-cpu_config.h?) ) */
#define SIMD_MAX 0 /* move this to configure ! */
#define SIMD_32  1
#define SIMD_16  2
#define SIMD_8   3
#define true     1
#define false    0

/* inputs and outputs : */

/* external FF of ASI EU: */
UMAX inc_in;     /* the operand */
UMAX inc_out;    /* the result */
bool inc_INC;
bool inc_DEC;
bool inc_ABS;
bool inc_NEG;
bool inc_LSB0;
bool inc_LSB1;
bool inc_simd;
u8   inc_size;

/* internal FF between stages: */
UMAX t_inc_in;
UMAX t_inc_out;
bool t_inc_INC;
bool t_inc_DEC;
bool t_inc_ABS;
bool t_inc_NEG;
bool t_inc_LSB0;
bool t_inc_LSB1;
bool t_inc_simd;
u8   t_inc_size;
 
/* problem : they should be enums !! */

static inline void cycle_inc (void);

#endif /* EU_INC_H */
